# -*- coding: shift_jis -*-
# --------------------------------------------------------------------
# MT Mirror Copy Ver.0.6 Written by Kyotaro
# ====================================================================
# Einglish Description:
# ---------------------
# This script spawn morph target in selected prop or figure, and 
# symmetrical copy or swap to morph.
# Work in Poser 7 or later.
# 
# Japanese Description:
# ---------------------
# ̃XNvg͌ݑIĂ鏬܂̓tBMA
# Ԃ[tAΏ̃Rs[܂͔]Rs[s܂B
# Poser 7ȍ~œ삵܂B
######################################################################

import poser
import os
from Numeric import *
from datetime import *

debugMode = 0
processID = 3
diff = 0.00001 # poser unit 0.0262128 Millimeter
axis = 0	# 0:x, 1:y, 2:z
enco = ""

vListOriginal = []
vListTarget = []
vListP = []
vListN = []
vListC = []
symList = []
oldDelta = []

#-----------------------------------------------------------------------------
# Setting language and dialog massage
#
# msgString List - 0. English 1. French 2. German 3. Japanese
# Now, French and German are unavailable.
#-----------------------------------------------------------------------------

msgString = []
msgString.append( ["MT Mirror Copy", u"", u"", u"MTʃRs["])	#0 Title
msgString.append( ["Select Menu", u"", u"", u"I"])			 #1 Menu Massage
msgString.append( ["+X to -X", u"", u"+X zu -X", u"+X-X"])	 #2 Menu list 01
msgString.append( ["-X to +X", u"", u"-X zu +X", u"-X+X"])	 #3 Menu list 02
msgString.append( ["Swap X", u"", u"Tauschen X", u"XŔ]"])		 #4 Menu list 03
msgString.append( ["+Y to -Y", u"", u"+Y zu -Y", u"+Y-Y"])	 #5 Menu list 04
msgString.append( ["-Y to +Y", u"", u"-Y zu +Y", u"-Y+Y"])	 #6 Menu list 05
msgString.append( ["Swap Y", u"", u"Tauschen Y", u"YŔ]"])		 #7 Menu list 06
msgString.append( ["+Z to -Z", u"", u"+Z zu -Z", u"+X-Z"])	 #8 Menu list 07
msgString.append( ["-Z to +Z", u"", u"-Z zu +Z", u"-X+Z"])	 #9 Menu list 08
msgString.append( ["Swap Z", u"", u"Tauschen Z", u"ZŔ]"])		#10 Menu list 09
msgString.append( ["Set Threshold", u"", u"", u"~lݒ"])		#11 Menu list 10
msgString.append( ["No Actor.\n", u"\n", u"\n", u"IĂ܂\n"])	#12 Error massage
msgString.append( ["Select prop or figure.", u"", u"", u"tBMA\nIĂ"])	#13 Error massage
msgString.append( ["No Geometry.", u"", u"", u"WIg܂"])	#14 Error massage
msgString.append( ["Symmetry part is not found.\nCoutinue at in current part ?", u"", u"", u"Ώ̂̃p[g܂\ñ݂p[gŏ𑱂܂H"])	#15 Error massage
msgString.append( ["Input is Not float.", u"", u"", u"͂܂"])	#16 Error massage
msgString.append( ["Not 0.000001 ~ 0.001", u"", u"", u"0.0000010.001̊Ԃ\n͂Ă"])	#17 Error massage
msgString.append( ["Process is ended.\nPlease delete dummy MT 'Dummy'", u"", u"", u"I܂\n[tDummy폜ĉ"])	#18 End massage
msgString.append( ["There are no Symmentry vertices.\nProcess is canceled.", u"", u"", u"Ώ̂̒_܂\n𒆒f܂"])	#19 Error massage

def poserLanguage():
	global enco
	if (os.name == "posix"):
		enco = "utf_8"
	else:
		enco = "shift-jis"
	l = poser.Language()
	if l == poser.kLanguageCodeUSENGLISH:
		return 0
#	elif l == poser.kLanguageCodeFRENCH:
#		return 1
#	elif l == poser.kLanguageCodeGERMAN:
#		return 2
	elif l == poser.kLanguageCodeJAPANESE:
		return 3
	else:
		return 0

def msgStr(msgNo):
	return msgString[msgNo][lang].encode(enco) 

#-----------------------------------------------------------------------------
# Select menu from list dialog
#-----------------------------------------------------------------------------

def selectMenu():
	global diff
	global axis
	global processID
	global targetAct

	menuList = [msgStr(2), msgStr(3), msgStr(4), msgStr(5), msgStr(6), msgStr(7), msgStr(8), msgStr(9), msgStr(10), msgStr(11)]
	if crntAct == targetAct:
		subList = menuList
	elif crntAct.InternalName()[0] == "r":
		subList = [msgStr(3), msgStr(5), msgStr(6), msgStr(7), msgStr(8), msgStr(9), msgStr(10), msgStr(11)]
	elif crntAct.InternalName()[0] == "l":
		subList = [msgStr(2), msgStr(5), msgStr(6), msgStr(7), msgStr(8), msgStr(9), msgStr(10), msgStr(11)]
	else:
		subList = menuList
	menuCmd = poser.DialogSimple.AskMenu(msgStr(0), msgStr(1), subList)

	if (menuCmd == menuList[0]) or (menuCmd == menuList[1]) or (menuCmd == menuList[2]):
		axis = 0
		processID =  menuList.index(menuCmd) % 3
		if debugMode >= 1:
			print "- Selected axis: X"
	elif (menuCmd == menuList[3]) or (menuCmd == menuList[4]) or (menuCmd == menuList[5]):
		axis = 1
		processID =  menuList.index(menuCmd) % 3
		if crntAct != targetAct:
			targetAct = crntAct
		if debugMode >= 1:
			print "- Selected axis: Y"
	elif (menuCmd == menuList[6]) or (menuCmd == menuList[7]) or (menuCmd == menuList[8]):
		axis = 2
		processID =  menuList.index(menuCmd) % 3
		if crntAct != targetAct:
			targetAct = crntAct
		if debugMode >= 1:
			print "- Selected axis: Z"
	elif (menuCmd == menuList[9]):
		diffDialog = poser.DialogTextEntry(None,"0.000001 ~ 0.001[PU]", "%0.6f" % diff)
		diffDialog.Show()
		try:
			temp = float(diffDialog.Text())
		except:
			poser.DialogSimple.MessageBox(msgStr(16))
			temp = 0
		if temp:
			if (temp >= 0.000001) and (temp <= 0.001):
				diff = temp
			else:
				poser.DialogSimple.MessageBox(msgStr(17))
		if debugMode >= 1:
			print "- New threshold: ", diff
		selectMenu()
	if debugMode >= 1:
		print "- Menu: ", menuCmd, ", Proccess: ", processID
	return processID
#-----------------------------------------------------------------------------
# get vertices from current actor and target actor.
#-----------------------------------------------------------------------------

def setVerticesList():
	for v in crntAct.Geometry().Vertices():
		vListOriginal.append([v.X(), v.Y(), v.Z()])
	for i, v in enumerate( targetAct.Geometry().Vertices()):
		if axis == 1:
			p = v.Y()
			vListTarget.append([v.X(), p, v.Z()])
		elif axis == 2:
			p = v.Z()
			vListTarget.append([v.X(), v.Y(), p])
		else:
			p = v.X()
			vListTarget.append([p, v.Y(), v.Z()])
		if p >= diff:
			vListP.append(i)
		elif p <= -diff:
			vListN.append(i)
		else:
			vListC.append(i)
	if debugMode >= 1:
		print "- Plus side vertices : ", len(vListP)
		print "- Minus side vertices: ", len(vListN)
		print "- Cneter vertices    : ", len(vListC)

def searchSymVer():
	if axis == 0:
		sub1 = 1
		sub2 = 2
	elif axis == 1:
		sub1 = 0
		sub2 = 2
	else:
		sub1 = 0
		sub2 = 1
	for v in vListOriginal:
		noMatch = 1
		if v[axis] >= diff:		# plus side
			for n in vListN:
				vv = vListTarget[n]
				if abs(vv[axis] + v[axis]) < diff:
					if abs(vv[sub1] - v[sub1]) < diff:
						if abs(vv[sub2] - v[sub2]) < diff:
							symList.append(n)
							noMatch = 0
							break
			if noMatch:
				symList.append("err")
		elif v[axis] <= -diff:	# minus side
			for n in vListP:
				vv = vListTarget[n]
				if abs(vv[axis] + v[axis]) < diff:
					if abs(vv[sub1] - v[sub1]) < diff:
						if abs(vv[sub2] - v[sub2]) < diff:
							symList.append(n)
							noMatch = 0
							break
			if noMatch:
				symList.append("err")
		else:
			for n in vListC:
				vv = vListTarget[n]
				if abs(vv[sub1] - v[sub1]) < diff:
					if abs(vv[sub2] - v[sub2]) < diff:
						symList.append(n)
						noMatch = 0
						break
			if noMatch:
				symList.append("err")
	if debugMode >= 2:
		"Symmetry list: ", symList
	return len(symList) - symList.count("err")

#-----------------------------------------------------------------------------
# Create dummy MT and get morph delta in current actor.
#-----------------------------------------------------------------------------

def getDelta():
	global oldDelta
	crntAct.SpawnTarget("Dummy")
	for p in crntAct.Parameters():
		if p.IsMorphTarget():
			prm = p
			break
	num = crntAct.Geometry().NumVertices()
	oldDelta = zeros((num,3), Float)

	i = 0
	while (i < targetAct.Geometry().NumVertices()):
		delta = prm.MorphTargetDelta(i)
		oldDelta[i] = delta
		i += 1
	return prm

def targetDelta(mode):
	name = "MT"
	if mode == 0:
		name = "MirrorMT +"
	elif mode == 1:
		name = "MirrorMT -"
	elif mode == 2:
		name = "SwapMT "
	if axis == 0:
		name += "X"
	elif axis == 1:
		name += "Y"
	elif axis == 2:
		name += "Z"

	if debugMode >= 1:
		print "- Created MT: ", name

	targetAct.SpawnTargetFromGeometry(targetAct.Geometry(), name)
	for p in targetAct.Parameters():
		if p.IsMorphTarget():
			prm = p
			break
	return prm

#-----------------------------------------------------------------------------
# Copy morph delta from dummy MT to target MT.
#-----------------------------------------------------------------------------

def copyDelta(prmT, mode):
	mat = array([[-1, 1, 1], [1, -1, 1], [1, 1, -1],[0, 1, 1], [1, 0, 1], [1, 1, 0]])
	mat1 = mat[axis]
	mat2 = mat[axis+3]
	newDelta = []
	if mode == 0:		# Plus to Minus
		copyList = vListN
		orgnList = vListP
	elif mode == 1:		# Minus to Plus
		copyList = vListP
		orgnList = vListN
	else:				# Swap
		copyList = vListN + vListP
	if debugMode >= 2:
		print "copyList: ", copyList #

	for n in copyList:
		if symList[n] != "err":
			d = oldDelta[symList[n]] * mat1
			newDelta.append([n, d[0], d[1], d[2]])

	if mode != 2:
		for n in orgnList:
			d = oldDelta[n]
			newDelta.append([n, d[0], d[1], d[2]])

	for cn in vListC:
		if symList[cn] != "err":
			if mode == 2:
				d = oldDelta[symList[cn]] * mat1
			else:
				d = oldDelta[symList[cn]] * mat2
			newDelta.append([cn, d[0], d[1], d[2]])
	newDelta.sort()
	if debugMode >= 2:
		for nd in newDelta: 
			print nd
	for newD in newDelta:
		prmT.SetMorphTargetDelta(newD[0], newD[1], newD[2], newD[3])
	poser.DialogSimple.MessageBox(msgStr(18))

#-----------------------------------------------------------------------------

def runProcess():
	if debugMode >= 1:
		print "* Start at: ", datetime.now() #
	menu = selectMenu()
	if menu != 3:
		if debugMode >= 1:
			print "- Original: ", crntAct.Name(), ", Target: ", targetAct.Name() #
		start = datetime.now()
		setVerticesList()
		if debugMode >= 1:
			print "***** Load vertices: ", datetime.now() - start, "*****" #
		num = searchSymVer()
		if debugMode >= 1:
			print "***** Search symmetry: ", datetime.now() - start, "*****" #
		if num == 0:
			poser.DialogSimple.MessageBox(msgStr(19))
		else:
			getDelta()
			copyDelta(targetDelta(menu), menu)
			if debugMode >= 1:
				print "***** Copy Delta: ", datetime.now() - start, "*****" #

#-----------------------------------------------------------------------------
# Main
#-----------------------------------------------------------------------------

scene = poser.Scene()
lang = poserLanguage()

if debugMode >= 1:
	print "****** Run script: MTMirrorCopy ******" #
	print "* Poser Version: ", poser.AppVersion(), "Python Version: ", sys.version #
	print "* Language: ", poser.Language(), ",  Massage lists: ", lang #

try:
	crntAct = scene.CurrentActor()
except:
	crntAct = 0

if crntAct:
	if crntAct.IsDeformer():
		try:
			crntAct = crntAct.Parent()
		except:
			crntAct = 0
	if crntAct:
		if crntAct.IsZone() or crntAct.IsBase():
			try:
				crntAct = crntAct.Parent()
			except:
				crntAct = 0
	if crntAct:
		try:
			scene.SelectActor(crntAct)
			orgnlGeo = crntAct.Geometry()
		except:
			orgnlGeo = 0
		if orgnlGeo:
			if crntAct.IsBodyPart():
				crntFig = crntAct.ItsFigure()
				if crntAct.InternalName()[0] == "r":
					try:
						targetAct = scene.ActorByInternalName("l" + crntAct.InternalName()[1:])
						try:
							targetGeo = targetAct.Geometry()
							runProcess()
						except:
							poser.DialogSimple.MessageBox(msgStr(14))
					except:
						if poser.DialogSimple.YesNo(msgStr(15)):
							targetAct = crntAct
							runProcess()
				elif crntAct.InternalName()[0] == "l":
					try:
						targetAct = scene.ActorByInternalName("r" + crntAct.InternalName()[1:])
						try:
							targetGeo = targetAct.Geometry()
							runProcess()
						except:
							poser.DialogSimple.MessageBox(msgStr(14))
					except:
						if poser.DialogSimple.YesNo(msgStr(15)):
							targetAct = crntAct
							runProcess()
				else:
					targetAct = crntAct
					runProcess()
			elif crntAct.IsProp():
				targetAct = crntAct
				runProcess()
			else:
				poser.DialogSimple.MessageBox(msgStr(13))
		else:
			poser.DialogSimple.MessageBox(msgStr(14))
	else:
		poser.DialogSimple.MessageBox(msgStr(12) + msgStr(13))
else:
	poser.DialogSimple.MessageBox(msgStr(12))

if debugMode >= 1:
	print "****** All process is ended. ******" #

#-----------------------------------------------------------------------------
